package com.iohao.mmo.equip.service;

/**
 * @author 唐斌
 * @date 2023-08-31
 * @description:
 */

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

/**
 * JAVA 返回随机数，并根据概率、比率
 *
 */
public class MathRandom {

    private static Log logger = LogFactory.getLog(MathRandom.class);

    /**
     * Math.random()产生一个double型的随机数，判断一下 每个奖品出现的概率
     *
     * @return int
     *
     */
    public int WeightRandom(List<RewardPrize> prizes) {
        int random = -2;
        try{
            double sumWeight = 0;
            //计算总权重
            for(RewardPrize rp_1 : prizes){
                sumWeight += rp_1.getPrize_weight();
            }
            double randomNumber;
            randomNumber = Math.random();
            double d1 = 0;
            double d2 = 0;

            for(int i=0;i<prizes.size();i++){
                d2 += Double.parseDouble(String.valueOf(prizes.get(i).getPrize_weight()))/sumWeight;
                if(i==0){
                    d1 = 0;
                }else{
                    d1 +=Double.parseDouble(String.valueOf(prizes.get(i-1).getPrize_weight()))/sumWeight;
                }
                if(randomNumber >= d1 && randomNumber <= d2){
                    random = i;
                    break;
                }
            }
        }catch(Exception e){
            System.out.println(e.getMessage());
            logger.error("生成抽奖随机数出错，出错原因：" + e.getMessage());
            random = -1;
        }
        return random;
    }

    /**
     * 测试主程序
     *
     * @param agrs
     */
    public static void main(String[] agrs) {
        MathRandom a = new MathRandom();
        List<RewardPrize> prizes = new ArrayList();
        List<RewardPrize> results = new ArrayList();
        prizes.add(new RewardPrize(10000,"一等奖",1,5));
        prizes.add(new RewardPrize(10001,"二等奖",5,10));
        prizes.add(new RewardPrize(10002,"四等奖",1000000,30));
        prizes.add(new RewardPrize(10003,"三等奖",1000000,20));
        prizes.add(new RewardPrize(10004,"安慰奖",1000000,35));

        int[] indexCount = new int[prizes.size()];

        for (int i = 0; i <= 850000; i++)// 打印100个测试概率的准确性
        {
            int index = a.WeightRandom(prizes);
            if(prizes.get(index).getPrize_amount()<=indexCount[index]){
                i--;
                continue;
            }
            indexCount[index] = indexCount[index] + 1;
            results.add(prizes.get(index));
        }
        System.out.println(indexCount[0]+"---"+indexCount[1]+"---"+indexCount[2]+"---"+indexCount[3]+"---"+indexCount[4]);

    }
    public static class RewardPrize  {
        private int rewardId;//奖励id
        private String rewardName;//奖励名称
        private int prize_amount;//数量
        private int prize_weight;//权重

        public String getRewardName() {
            return rewardName;
        }

        public void setRewardName(String rewardName) {
            this.rewardName = rewardName;
        }

        public int getPrize_amount() {
            return prize_amount;
        }

        public void setPrize_amount(int prize_amount) {
            this.prize_amount = prize_amount;
        }

        public int getPrize_weight() {
            return prize_weight;
        }

        public void setPrize_weight(int prize_weight) {
            this.prize_weight = prize_weight;
        }

        public RewardPrize() {
        }

        public RewardPrize(int rewardId, String rewardName, int prize_amount, int prize_weight) {
            this.rewardId = rewardId;
            this.rewardName = rewardName;
            this.prize_amount = prize_amount;
            this.prize_weight = prize_weight;
        }
    }
}

