package com.iohao.mmo.excel.dto;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.alibaba.excel.annotation.write.style.ContentRowHeight;
import com.alibaba.excel.annotation.write.style.HeadRowHeight;
import lombok.Data;

import java.math.BigDecimal;

/**
 * 装备词条Excel
 *
 * @author Toby javatangbin@163.com
 */
@Data
@ContentRowHeight(20)
@HeadRowHeight(20)
@ColumnWidth(25)
public class EquipTemplateExcelDTO {
    @ColumnWidth(20)
    @ExcelProperty(value ="itemTypeId",index = 0)
    private String itemTypeId;

    @ExcelProperty(value ="部位",index = 1)
    private String position;

    @ColumnWidth(20)
    @ExcelProperty(value = "要求等级",index = 2)
    private int level;

    @ExcelProperty(value = "品质",index = 3)
    private int quality;

    @ColumnWidth(20)
    @ExcelProperty(value = "耐久度",index = 4)
    private int durability;

    @ExcelProperty(value = {"装备基础属性范围","物理攻击最小值"},index = 5)
    private Integer physicsAttackMin;

    @ExcelProperty(value = {"装备基础属性范围","物理攻击最大值"},index = 6)
    private Integer physicsAttackMax;

    @ExcelProperty(value = {"装备基础属性范围","法术攻击最小值"},index = 7)
    private Integer magicAttackMin;

    @ExcelProperty(value = {"装备基础属性范围","法术攻击最大值"},index = 8)
    private Integer magicAttackMax;

    @ExcelProperty(value = {"装备基础属性范围","物理攻击速度"},index = 9)
    private Integer physicsAttackSpeed;

    @ExcelProperty(value = {"装备基础属性范围","法术攻击速度"},index = 10)
    private Integer magicAttackSpeed;

    @ExcelProperty(value = {"装备基础属性范围","物理防御"},index = 11)
    private Integer physicsDefense;

    @ExcelProperty(value = {"装备基础属性范围","法术防御"},index = 12)
    private Integer magicDefense;

    @ExcelProperty(value = {"装备基础属性范围","物理命中"},index = 13)
    private Integer physicsHit;

    @ExcelProperty(value = {"装备基础属性范围","法术命中"},index = 14)
    private Integer magicHit;

    @ExcelProperty(value = {"装备基础属性范围","物理躲避"},index = 15)
    private Integer physicsDodge;

    @ExcelProperty(value = {"装备基础属性范围","法术躲避"},index = 16)
    private Integer magicDodge;

    @ExcelProperty(value = {"装备基础属性范围","生命值"},index = 17)
    private Integer hp;

    @ExcelProperty(value = {"装备基础属性范围","能量值"},index = 18)
    private Integer mp;

    @ExcelProperty(value = {"装备固定属性","属性编码"},index = 19)
    private String code;


}
